aboutsummaryrefslogtreecommitdiff
path: root/git-stash.sh
diff options
context:
space:
mode:
authorJunio C Hamano <gitster@pobox.com>2007-07-08 01:38:32 -0700
committerJunio C Hamano <gitster@pobox.com>2007-09-14 22:40:49 -0700
commitbc9e7399af3790918140c30a5b2c85bf9a8f1ad3 (patch)
treeaa288af4723d7d99af2b5dc47736ac6a0ce49ce0 /git-stash.sh
parentd3392f7e86d130dfafb08736b7fa2067dd2cf070 (diff)
downloadgit-bc9e7399af3790918140c30a5b2c85bf9a8f1ad3.tar.gz
git-bc9e7399af3790918140c30a5b2c85bf9a8f1ad3.tar.xz
stash: implement "stash create"
This subcommand creates a stash from the current state and writes out the resulting commit object ID to the standard output, without updating the stash ref nor resetting the tree. It is intended to be used by scripts to temporarily rewind the working tree to a clean state. Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'git-stash.sh')
-rwxr-xr-xgit-stash.sh28
1 files changed, 21 insertions, 7 deletions
diff --git a/git-stash.sh b/git-stash.sh
index 7ba61625b..04af89253 100755
--- a/git-stash.sh
+++ b/git-stash.sh
@@ -25,19 +25,13 @@ clear_stash () {
fi
}
-save_stash () {
+create_stash () {
stash_msg="$1"
if no_changes
then
- echo >&2 'No local changes to save'
exit 0
fi
- test -f "$GIT_DIR/logs/$ref_stash" ||
- clear_stash || die "Cannot initialize stash"
-
- # Make sure the reflog for stash is kept.
- : >>"$GIT_DIR/logs/$ref_stash"
# state of the base commit
if b_commit=$(git rev-parse --verify HEAD)
@@ -84,7 +78,20 @@ save_stash () {
w_commit=$(printf '%s\n' "$stash_msg" |
git commit-tree $w_tree -p $b_commit -p $i_commit) ||
die "Cannot record working tree state"
+}
+save_stash () {
+ stash_msg="$1"
+
+ if no_changes
+ then
+ echo >&2 'No local changes to save'
+ exit 0
+ fi
+ test -f "$GIT_DIR/logs/$ref_stash" ||
+ clear_stash || die "Cannot initialize stash"
+
+ create_stash "$stash_msg"
git update-ref -m "$stash_msg" $ref_stash $w_commit ||
die "Cannot save the current status"
printf >&2 'Saved "%s"\n' "$stash_msg"
@@ -202,6 +209,13 @@ apply)
clear)
clear_stash
;;
+create)
+ if test $# -gt 0 && test "$1" = create
+ then
+ shift
+ fi
+ create_stash "$*" && echo "$w_commit"
+ ;;
help | usage)
usage
;;